package org.one.stone.soup.browser.cache;

import org.one.stone.soup.browser.*;
import org.one.stone.soup.mjdb.data.field.*;
import org.one.stone.soup.mjdb.data.group.*;

/*
 * Wet-Wired.com Browser Helpers Version Date 27-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.co.uk/pages/licence-os.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class SimpleResourceStore extends Table implements ResourceStore,Runnable{

	private static final int TTL = 60000;

	private static int URL_COL = 0;
	private static int RESOURCE_COL = 1;
	private static int ACCESS_TIME_COL = 2;

	private static int COLUMNS = 3;
public SimpleResourceStore() {
	super(COLUMNS);

	try{
		setColumnTitle(URL_COL,"url",this);
		setColumnTitle(RESOURCE_COL,"resource",this);
		setColumnTitle(ACCESS_TIME_COL,"accessTime",this);
	}
	catch(Exception e){}

	new Thread(this,"ResourceStore Monitor").start();
}
public Object retrieve(String url)
{
	Object resource = null;
	try{
		int index = findInCol(URL_COL,url);
		if(index!=-1)
		{
			resource = getField(RESOURCE_COL,index);
			setField(ACCESS_TIME_COL,index,new LongField(System.currentTimeMillis()),this);
		}
	}catch(Exception e){}

	return resource;
}
/**
 * run method comment.
 */
public void run()
{
	while(true)
	{
	try{
		try{ Thread.sleep(1000); }catch(Exception e){}

		for(int loop=0;loop<getNoOfRows();loop++)
		{
			long accessTime = ((LongField)getField(ACCESS_TIME_COL,loop)).getValue();
			if( System.currentTimeMillis()-accessTime>=TTL )
			{
				String url = getField(URL_COL,loop).toString();
				removeRow( loop,this );
				//System.out.println("Uncached "+url);
			}
		}
	}
	catch(Exception e){}
	}
}
public void store(String url, Object resource)
{
	try{
		Row row = new Row(COLUMNS);
		row.setField(URL_COL,url,this);
		row.setField(RESOURCE_COL,resource,this);
		row.setField(ACCESS_TIME_COL,new LongField(System.currentTimeMillis()),this);
		addRow(row,resource);

		//System.out.println("Cached "+url);
	}catch(Exception e){}
}
}
