package org.one.stone.soup.file;

import java.io.File;
import java.io.IOException;


public class LiveFileString {

	private File file;
	private String data;
	private FileWatch fileWatch;
	private IOException ioException;
	
	private class Watcher implements FileChangeListener
	{
		public void fileChanged(File file)
		{
			try{
				forceRefresh();
			}
			catch(IOException e)
			{
				ioException=e;
			}
		}
	}
	
	public LiveFileString(String fileName) throws IOException
	{
		file = new File(fileName);
		forceRefresh();
		
		fileWatch = new FileWatch(fileName,10000);
		fileWatch.addListener( new Watcher() );
	}

	public LiveFileString(String fileName,long refreshMillis) throws IOException
	{
		file = new File(fileName);
		forceRefresh();
		
		fileWatch = new FileWatch(fileName,(int)refreshMillis);
		fileWatch.addListener( new Watcher() );
	}
	
	public void forceRefresh() throws IOException
	{
		data = FileHelper.readFile(file.getAbsolutePath());		
	}

	public String getData() throws IOException
	{
		if(ioException!=null)
		{
			throw ioException;
		}
		return data;
	}
}
