package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The Point3DField class is a wrapper for combined x, y and z int values.
	* @author Nik Cross
*/

public class Point3DField extends Field {
	public static String DEFAULT_ID = "_Point3D";

	private IntField x = new IntField(0);
	private IntField y = new IntField(0);
	private IntField z = new IntField(0);
public Point3DField() {
	super();
}
public Point3DField(int x,int y,int z) {
	super();

	try{
		this.x.setValue(x,this);
		this.y.setValue(y,this);
		this.z.setValue(z,this);
	}
	catch(LockException le)
	{}//Dummy catch
}
public int compare(Field target) throws CompareException {

	throw new CompareException("Can't compare "+target+" not implemented");

}
/**
 * getValue method comment.
 */
public String getValue(String name) {
	if(name.equals("x"))
	{
		return ""+getValueX();
	}
	else if(name.equals("xMin"))
	{
		return ""+getValueXMin();
	}
	else if(name.equals("xMax"))
	{
		return ""+getValueXMax();
	}
	else if(name.equals("y"))
	{
		return ""+getValueY();
	}
	else if(name.equals("yMin"))
	{
		return ""+getValueYMin();
	}
	else if(name.equals("yMax"))
	{
		return ""+getValueYMax();
	}
	else if(name.equals("z"))
	{
		return ""+getValueZ();
	}
	else if(name.equals("zMin"))
	{
		return ""+getValueZMin();
	}
	else if(name.equals("zMax"))
	{
		return ""+getValueZMax();
	}
	return "?";
}
public int getValueX() {
	return x.getValue();
}
public int getValueXMax() {
	return x.getValueMax();
}
public int getValueXMin() {
	return x.getValueMin();
}
public int getValueY() {
	return y.getValue();
}
public int getValueYMax() {
	return y.getValueMax();
}
public int getValueYMin() {
	return y.getValueMin();
}
public int getValueZ() {
	return z.getValue();
}
public int getValueZMax() {
	return z.getValueMax();
}
public int getValueZMin() {
	return z.getValueMin();
}
public boolean hasChanged() {
	return x.hasChanged() | y.hasChanged() | z.hasChanged();
}
/**
 * Insert the method's description here.
 * Creation date: (23/07/00 08:55:54)
 * @param newX int
 */
public void setRange(int newXValueMin,int newYValueMin,int newZValueMin,int newXValueMax,int newYValueMax,int newZValueMax) {

	x.setValueMin(newXValueMin);
	x.setValueMax(newXValueMax);
	y.setValueMin(newYValueMin);
	y.setValueMax(newYValueMax);
	z.setValueMin(newZValueMin);
	z.setValueMax(newZValueMax);
}
/**
 * setValue method comment.
 */
public void setValue(String name, String value, Object source) throws LockException
{
	if(name.equals("x"))
	{
		setValueX( Integer.parseInt(value),this );
	}
	else if(name.equals("y"))
	{
		setValueY( Integer.parseInt(value),this );
	}
	else if(name.equals("z"))
	{
		setValueZ( Integer.parseInt(value),this );
	}
	else if(name.equals("xMin"))
	{
		setValueXMin( Integer.parseInt(value) );
	}
	else if(name.equals("xMax"))
	{
		setValueXMax( Integer.parseInt(value) );
	}
	else if(name.equals("yMin"))
	{
		setValueYMin( Integer.parseInt(value) );
	}
	else if(name.equals("yMax"))
	{
		setValueYMax( Integer.parseInt(value) );
	}
	else if(name.equals("zMin"))
	{
		setValueZMin( Integer.parseInt(value) );
	}
	else if(name.equals("zMax"))
	{
		setValueZMax( Integer.parseInt(value) );
	}
}
public void setValueX(int newData,Object source) throws LockException {

	x.setValue(newData,this);

	if(report)
		reportChange(source);
}
public void setValueXMax(int newXValueMax) {
	x.setValueMax(newXValueMax);
}
public void setValueXMin(int newXValueMin) {
	x.setValueMin(newXValueMin);
}
public void setValueY(int newData,Object source) throws LockException {

	y.setValue(newData,this);

	if(report)
		reportChange(source);
}
public void setValueYMax(int newYValueMax) {
	y.setValueMax(newYValueMax);
}
public void setValueYMin(int newYValueMin) {
	y.setValueMin(newYValueMin);
}
public void setValueZ(int newData,Object source) throws LockException {

	z.setValue(newData,this);

	if(report)
		reportChange(source);
}
public void setValueZMax(int newZValueMax) {
	z.setValueMax(newZValueMax);
}
public void setValueZMin(int newZValueMin) {
	z.setValueMin(newZValueMin);
}
public String toString() {
	return ""+x.toString()+","+y.toString()+","+z.toString();
}
}
