/*
 * Created on 05-Aug-05
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.one.stone.soup.swing;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import org.one.stone.soup.stringhelper.StringArrayHelper;

	public class SourceConsole extends JRootFrame implements ActionListener
	{
		private boolean complete = false;
		private JTextConsole textConsole;
		
		public SourceConsole(String source)
		{
			super("Source View",new String[]{});
			
			textConsole = new JTextConsole();
			textConsole.setBackground(new Color(0,40,0));
			textConsole.setForeground(new Color(50,250,50));
			textConsole.getComponent().setFont( new Font("Courier",Font.BOLD,14) );

			setSource(source);

			getContentPane().add(textConsole,BorderLayout.NORTH);
			
			JMenuItem exit = new JMenuItem( "Exit" );
			exit.addActionListener(this);
			
			JMenu file = new JMenu("File");
			file.add(exit);

			
			JMenuItem clear = new JMenuItem( "Clear" );
			clear.addActionListener(this);

			JMenuItem find = new JMenuItem( "Find" );
			find.addActionListener(this);

			JMenuItem replace = new JMenuItem( "Replace" );
			replace.addActionListener(this);


			JMenu edit = new JMenu("Edit");
			edit.add(clear);
			edit.add(find);
			edit.add(replace);

			JMenuBar menuBar = new JMenuBar();
			menuBar.add(file);
			menuBar.add(edit);

			setJMenuBar( menuBar );

			this.pack();
			this.setVisible(true);
		}

		/* (non-Javadoc)
		 * @see org.one.stone.soup.swing.JRootFrame#destroy()
		 */
		public boolean destroy() {

			setVisible(false);
			dispose();
			complete = true;

			return false;
		}

		public String getSourceOnExit()
		{
			while(complete==false)
			{
				try{ Thread.sleep(1000); }catch(Exception e){}
			}
			
			return getSource();
		}
		
		public void actionPerformed(ActionEvent action)
		{
			String command = action.getActionCommand().toLowerCase();

			if( command.equals("exit") )
			{
				destroy();
			}
			else if( command.equals("clear") )
			{
				textConsole.clear();
			}
			else if( command.equals("find") )
			{
				String selected = textConsole.getSelected();
				if(selected==null)
				{
					selected="";
				}

				String find = JOptionPane.showInputDialog(this,"Find",selected);
				textConsole.find(find);
			}
			else if( command.equals("replace") )
			{
				String selected = textConsole.getSelected();
				if(selected==null)
				{
					selected="";
				}

				String find = JOptionPane.showInputDialog(this,"Find",selected);
				String replace = JOptionPane.showInputDialog(this,"Replace With");

				textConsole.replace(find,replace);
			}
			else if( command.equals("distinct") )
			{
				String data = textConsole.getText();

				String[] items = StringArrayHelper.parseFields(data,"\n\r");

				System.out.println(items.length);

				Hashtable hash = new Hashtable();
				for(int loop=0;loop<items.length;loop++)
				{
					hash.put(items[loop],items[loop]);
				}
				Object[] itemObjects = hash.keySet().toArray();
				items = new String[ itemObjects.length ];
				for(int loop=0;loop<items.length;loop++)
				{
					items[loop] = itemObjects[loop].toString();
				}
				items = StringArrayHelper.sort( items,StringArrayHelper.ASCENDING );

				System.out.println(items.length);

				data = StringArrayHelper.arrayToString(items,"\n");

				textConsole.setText(data);
			}
			else if( command.equals("sort ascending") )
			{
				String data = textConsole.getText();

				String[] items = StringArrayHelper.parseFields(data,"\n\r");
				items = StringArrayHelper.sort( items,StringArrayHelper.ASCENDING );
				data = StringArrayHelper.arrayToString(items,"\n");

				textConsole.setText(data);
			}
			else if( command.equals("sort descending") )
			{
				String data = textConsole.getText();

				String[] items = StringArrayHelper.parseFields(data,"\n\r");
				items = StringArrayHelper.sort( items,StringArrayHelper.DESCENDING );
				data = StringArrayHelper.arrayToString(items,"\n");

				textConsole.setText(data);

			}
			else if( command.equals("sort special") )
			{
				String data = textConsole.getText();

				String[] rows = StringArrayHelper.parseFields(data,"\n\r");
				StringBuffer buffer = new StringBuffer();

				for(int loop=0;loop<rows.length;loop++)
				{
					String[] fields = StringArrayHelper.parseFields( rows[loop],"\t" );

					int oldId = Integer.parseInt(fields[1]);

					boolean shouldChange = false;
					if( (oldId&8)>0 && (oldId&4096)>0 )
					{
						shouldChange = true;
					}

					if( !fields[1].equals(fields[2]) && shouldChange==false )
					{
						buffer.append(loop);
						buffer.append(" ");
						buffer.append( rows[loop] );
						buffer.append("\n");
					}
				}

				textConsole.setText( buffer.toString() );

			}
		}

		public void setSource(String source)
		{
			textConsole.setText(source);
		}

		public String getSource()
		{
			return textConsole.getText();
		}
	}
