package org.one.stone.soup.xapp.factories;

import java.io.File;

import org.one.stone.soup.xapp.XappPlugin;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.stream.XmlLoader;

public class XappPluginFactory {

	
	public static XappPlugin buildPlugin( File pluginFile )
	{
		XmlElement xPlugin = XmlLoader.load( pluginFile.getAbsolutePath() );
		
		String className = xPlugin.getAttributeValueByName("class");
		String name = xPlugin.getAttributeValueByName("name");
		
		XappPlugin plugin = null;
		try{
			plugin = (XappPlugin)Class.forName(className).getConstructor(new Class[]{String.class,XmlElement.class}).newInstance(new Object[]{pluginFile.getAbsolutePath(),xPlugin});
		}
		catch(Exception e)
		{
			XappRootApplication.displayException(e);
		}
		
		return plugin;
	}
	
	public static XmlElement getActionsDefinition()
	{
		XmlElement xActions = new XmlElement("actions");
		return xActions;
	}
	
	public static void addAction(XappPlugin plugin,XmlElement xActions,String name)
	{
			XmlElement xAction = xActions.addChild("action");
			xAction.addAttribute("name",name);
			xAction.addAttribute("plugin",plugin.getAlias());				
	}
	
	public static void addAction(XappPlugin plugin,XmlElement xActions,String name,String method)
	{
			XmlElement xAction = xActions.addChild("action");
			xAction.addAttribute("name",name);
			xAction.addAttribute("method",method);
			xAction.addAttribute("plugin",plugin.getAlias());				
	}
}
