package org.one.stone.soup.xapp.swing.components;

import java.awt.Dimension;
import java.awt.event.ActionListener;

import javax.swing.JProgressBar;
import javax.swing.JSlider;
import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;

import org.one.stone.soup.xapp.components.XappSlider;

public class XappSwingSlider extends JSlider implements XappSlider {

	public XappSwingSlider()
	{
		setMinimumSize(new Dimension(400,20));
		setPaintLabels(true);
		setPaintTicks(true);
		setPaintTrack(true);
		setBorder( new SoftBevelBorder(BevelBorder.RAISED) );
	}
	
	public String getData() {
		return ""+getValue();
	}

	public void setData(String value) {
		setValue(Integer.parseInt(value));
	}

	public void setEditable(boolean state) {
		setEnabled(state);
	}

	public void setOrientation(String orientation) {
		int orientationValue = JProgressBar.HORIZONTAL;

		if(orientation!=null && orientation.equals("vertical"))
		{
			orientationValue = JProgressBar.VERTICAL;
		}
		
		setOrientation(orientationValue);
	}

	public void setSize(int size) {
		setMinimumSize( new Dimension(getHeight(),size) );
	}

	public void addActionListener(ActionListener actionListener) {
		//slider.addChangeListener(container);
	}

	public void setTip(String toolTip) {
		setToolTipText(toolTip);
	}

	public void setMaximum(String value) {
		setMaximum( Integer.parseInt(value) );
		setTicks();
	}

	public void setMinimum(String value) {
		setMinimum( Integer.parseInt(value) );
		setTicks();
	}

	private void setTicks()
	{
		setMinorTickSpacing( (getMaximum()-getMinimum())/10 );
		setMajorTickSpacing( (getMaximum()-getMinimum())/5 );
	}
}
